'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _print = require('./print');

var _print2 = _interopRequireDefault(_print);

var _config = require('../config');

var config = _interopRequireWildcard(_config);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (type, key, value) {
  switch (type) {
    case 'get':
      if ((0, _lodash.isNil)(key)) {
        _print2.default.config(config.getConfig());
      } else if (config.keys.validate(key)) {
        _print2.default.config(config.getConfig(), key);
      } else {
        _print2.default.error('Input error', 'Invalid key \'' + key + '\'');
      }
      break;
    case 'set':
      if (config.keys.validate(key, value)) {
        var newConfig = config.setConfig(key, value);
        _print2.default.config(newConfig, key);
      } else {
        _print2.default.error('Input error', 'Invalid key \'' + key + '\' and value \'' + value + '\'');
      }
      break;
    default:
      _print2.default.error('Input type', 'Invalid type \'' + type + '\'. Only \'set\' and \'get\' is available');
  }
};