'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _leftPad = require('left-pad');

var _leftPad2 = _interopRequireDefault(_leftPad);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _coPrompt = require('co-prompt');

var _coPrompt2 = _interopRequireDefault(_coPrompt);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _github = require('../github/github');

var _gist = require('../github/gist');

var _download = require('../download');

var _config = require('../config');

var _print = require('./print');

var _print2 = _interopRequireDefault(_print);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var gist = (0, _config.getConfig)('repository.gist');

  var getGistAndDownload = gist && gist.length ? (0, _gist.get)(gist).then(executeDownload) : _promise2.default.reject({ code: 404 });

  getGistAndDownload.catch(function (e) {
    // Gist id is not set or invalid gist id
    if (e && e.code === 404) {
      (0, _co2.default)(_regenerator2.default.mark(function _callee() {
        var gistId;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _print2.default.error('Invalid gist', 'Gist id is not set or invalid.');
                _context.next = 3;
                return (0, _coPrompt2.default)(_chalk2.default.green('Gist id: '));

              case 3:
                gistId = _context.sent;

                (0, _gist.get)(gistId).then(function (_ref) {
                  var id = _ref.data.id;
                  return (0, _config.setConfig)('repository.gist', id);
                }).then(executeDownload).catch(function (_ref2) {
                  var message = _ref2.message,
                      others = (0, _objectWithoutProperties3.default)(_ref2, ['message']);
                  return _print2.default.error('GIST ERROR', message + ' ' + (0, _stringify2.default)(others));
                }).then(function () {
                  return process.stdin.pause();
                });

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
  });
};

var executeDownload = function executeDownload() {
  return (0, _download.download)().then(function (downloadedFiles) {
    _print2.default.info('Downloaded files successfully.');
    _print2.default.info(downloadedFiles.map(function (_ref3) {
      var name = _ref3.name,
          path = _ref3.path;
      return (0, _leftPad2.default)(name, 15) + ' > ' + path;
    }).join('\n'));
  });
};