'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _lodash = require('lodash');

var _version = require('../version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var printConfigPair = function printConfigPair(config, key) {
  return print.info(key + ' = ' + (0, _lodash.get)(config, key));
};


var printConfigObject = function printConfigObject(config) {
  return (0, _keys2.default)(config).forEach(function (k) {
    return printConfigPair(config, k);
  });
};

var print = {
  config: function config(_config, key) {
    return (0, _lodash.isNil)(key) ? printConfigObject(_config) : printConfigPair(_config, key);
  },
  info: function info() {
    var _console;

    return (_console = console).log.apply(_console, arguments);
  },
  warn: function warn() {
    var _console2;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_console2 = console).log.apply(_console2, (0, _toConsumableArray3.default)(args.map(function (a) {
      return _chalk2.default.bold.yellow(a);
    })));
  },
  error: function error(type, message) {
    return console.error(_chalk2.default.red('ERROR: ' + (type || '') + ' - ' + (message || '')));
  }
};

exports.default = print;