'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validate = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var keyMap = {
  'repository.type': /(gist)/,
  'repository.gist': /[\W]*/,
  'repository.githubToken': /[\w\W]*/,
  'file.createBackup': /(true|false)/
};


var keys = (0, _keys2.default)(keyMap);

keys.forEach(function (key) {
  exports[key] = keyMap[key];
});

var validate = exports.validate = function validate() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var _args = (0, _slicedToArray3.default)(args, 2),
      key = _args[0],
      value = _args[1];

  if (key.match(/path\.*/)) return true;

  if (!(0, _lodash.has)(keyMap, key)) return false;

  if (args.length > 1) {
    if ((0, _lodash.isNil)(value)) return false;

    return String(value).match(keyMap[key]) !== null;
  }

  return keyMap.hasOwnProperty(key);
};