'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _fsExtra = require('fs-extra');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _jsonStableStringify = require('json-stable-stringify');

var _jsonStableStringify2 = _interopRequireDefault(_jsonStableStringify);

var _paths = require('../paths');

var _config = require('../config');

var _gist = require('../github/gist');

var gist = _interopRequireWildcard(_gist);

var _version = require('../version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var linkFiles = function linkFiles() {
  var config = (0, _config.getConfig)();
  return _promise2.default.resolve((0, _keys2.default)(config).filter(function (key) {
    return key.startsWith('path.');
  }).map(function (key) {
    var file = key.substr(5);
    var filePath = config[key];

    if (_fs2.default.existsSync(filePath) && !_fs2.default.statSync(filePath).isSymbolicLink()) {
      (0, _fsExtra.copySync)(filePath, filePath + '.bak');
      (0, _fsExtra.removeSync)(filePath);
    }

    (0, _fsExtra.ensureSymlinkSync)(_path2.default.join(_paths.appDir, file), filePath);

    return {
      name: file,
      path: filePath
    };
  }));
};

exports.default = function () {
  var repoType = (0, _config.getConfig)('repository.type');

  if (!repoType) throw new Error('Specify the repository type using \'icbm config set <key> <value>\'');

  switch (repoType) {
    case 'gist':
      return gist.get((0, _config.getConfig)('repository.gist')).then(function (res) {
        var files = res.data.files;
        var fileList = (0, _keys2.default)(files);
        for (var i = 0, len = fileList.length; i < len; i++) {
          var file = fileList[i];
          var content = files[file].content;
          _fs2.default.writeFileSync(_path2.default.join(_paths.appDir, file), content === 'EMPTY_CONTENT' ? '' : content, {
            encoding: 'utf8'
          });
        }

        return linkFiles();
      });
    default:
      return _promise2.default.reject({
        message: repoType + ' is not supported yet.',
        id: 'Invalid repository type'
      });
  }
};