'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.edit = exports.get = exports.create = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _github = require('./github');

var _github2 = _interopRequireDefault(_github);

var _config = require('../config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var create = exports.create = function create() {
  var option = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  (0, _github.authenticate)();

  return _github2.default.gists.create((0, _extends3.default)({
    description: 'Gist for icbm',
    public: false
  }, option)).then(function (res) {
    return (0, _config.setConfig)('repository.gist', res.data.id);
  });
};

var get = exports.get = function get(id) {
  id = id || (0, _config.getConfig)('repository.gist');

  if (!id || !id.length) return _promise2.default.reject({ message: 'ID is empty' });

  return _github2.default.gists.get({ id: id });
};

var edit = exports.edit = function edit(files) {
  (0, _github.authenticate)();

  return _github2.default.gists.edit({
    id: (0, _config.getConfig)('repository.gist'),
    files: files
  });
};