'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authenticate = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _github = require('github');

var _github2 = _interopRequireDefault(_github);

var _config = require('../config');

var _getEnvVar = require('get-env-var');

var _getEnvVar2 = _interopRequireDefault(_getEnvVar);

var _version = require('../version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var github = new _github2.default({
  debug: (0, _getEnvVar2.default)('NODE_ENV', 'development') !== 'production',
  headers: {
    'user-agent': 'icbm v' + _version2.default + ', node v' + process.versions.node
  }
});

exports.default = github;
var authenticate = exports.authenticate = function authenticate() {
  var token = (0, _config.getConfig)('repository.githubToken');

  if (!token) throw new Error('Set github token using \'icbm config set repository.githubToken <token>\'');

  github.authenticate({ type: 'oauth', token: token });
  return _promise2.default.resolve();
};