'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUploadingFiles = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _jsonStableStringify = require('json-stable-stringify');

var _jsonStableStringify2 = _interopRequireDefault(_jsonStableStringify);

var _lodash = require('lodash');

var _paths = require('../paths');

var _config = require('../config');

var _gist = require('../github/gist');

var gist = _interopRequireWildcard(_gist);

var _version = require('../version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getUploadingFiles = exports.getUploadingFiles = function getUploadingFiles() {
  var files = _fs2.default.readdirSync(_paths.appDir).reduce(function (filesObject, file) {
    var content = _fs2.default.readFileSync(_path2.default.join(_paths.appDir, file), 'utf8');

    filesObject[file] = {
      content: content.trim().length || content.trim() === '\n' ? content : 'EMPTY_CONTENT'
    };

    return filesObject;
  }, {});

  files.syncInfo = {
    content: (0, _jsonStableStringify2.default)({
      version: _version2.default,
      lastUpdated: new Date().toISOString()
    }) + '\n'
  };
  return files;
};

exports.default = function () {
  var repoType = (0, _config.getConfig)('repository.type');

  if (!repoType) throw new Error('Specify the repository type using \'icbm config set repository.type <type>\'');

  switch (repoType) {
    case 'gist':
      var files = getUploadingFiles();

      return gist.get((0, _config.getConfig)('repository.gist')).then(function (res) {
        var deleted = (0, _keys2.default)(res.data.files).filter(function (f) {
          return !(0, _lodash.has)(files, f);
        });
        deleted.forEach(function (f) {
          return files[f] = null;
        });
        return gist.edit(files).then(function () {
          return _promise2.default.resolve({
            uploaded: _lodash.without.apply(undefined, [(0, _keys2.default)(files)].concat((0, _toConsumableArray3.default)(deleted))),
            deleted: deleted
          });
        });
      });
    default:
      return _promise2.default.reject({
        message: repoType + ' is not supported yet.',
        id: 'Invalid repository type'
      });
  }
};